// CC BY
// code by SASANO Takayoshi

#define	COMMAND_CLEAR		0x00
#define	STRING_CLEAR		"CLEAR "

struct command_clear_arg {
	unsigned char	cn;
};

#define	COMMAND_LINE		0x01
#define	STRING_LINE		"LINE "

struct command_line_arg {
	signed char	x1;
	signed char	y1;
	signed char	x2;
	signed char	y2;
	signed char	cn;
};

#define	COMMAND_STAMP		0x02
#define	STRING_STAMP		"STAMP "

struct command_stamp_arg {
	signed char	px;
	signed char	py;
	unsigned char	tc;
	unsigned char	cc[32];
};

#define	COMMAND_STAMP1		0x03
#define	STRING_STAMP1		"STAMP1 "

struct command_stamp1_arg {
	signed char	px;
	signed char	py;
	unsigned char	cn;
	unsigned char	cc[8];
};

#define	COMMAND_IMAGE		0x04
#define	STRING_IMAGE		"IMAGE "

struct command_image_arg {
	unsigned char	in;
};

#define	COMMAND_VIDEO		0x05
#define	STRING_VIDEO		"VIDEO "

struct command_video_arg {
	unsigned char	os;
};

#define	COMMAND_SPRITE_START	0x06
#define	STRING_SPRITE_START	"SPRITE START "

struct command_sprite_start_arg {
	unsigned char	in;
};

#define	COMMAND_SPRITE_CREATE	0x07
#define	STRING_SPRITE_CREATE	"SPRITE CREATE "

struct command_sprite_create_arg {
	unsigned char	sn;
	unsigned char	si;
};

#define	COMMAND_SPRITE_MOVE	0x08
#define	STRING_SPRITE_MOVE	"SPRITE MOVE "

struct command_sprite_move_arg {
	unsigned char	sn;
	signed char	px;
	signed char	py;
};

#define	COMMAND_SOUND		0x09
#define	STRING_SOUND		"SOUND "

struct sound {
	unsigned char	o;
	unsigned char	s;
};

struct command_sound_arg {
	struct sound	c[4];
};

#define	COMMAND_SOUND1		0x0a
#define	STRING_SOUND1		"SOUND1 "

struct command_sound1_arg {
	unsigned char	ch;
	struct sound	c;
};

#define	COMMAND_MUSIC_SCORE	0x0b
#define	STRING_MUSIC_SCORE	"MUSIC SCORE "

struct command_music_score_arg {
	unsigned char	ch;
	unsigned char	pn;
	unsigned char	tt;
	unsigned char	mm[64];
};

#define	COMMAND_MUSIC_PLAY	0x0c
#define	STRING_MUSIC_PLAY	"MUSIC PLAY "

struct command_music_play_arg {
	unsigned char	ss;
};

#define	COMMAND_RESET		0x0d
#define	STRING_RESET		"RESET"

/* no argument */

#define	COMMAND_CIRCLE		0x0e
#define	STRING_CIRCLE		"CIRCLE "

struct command_circle_arg {
	signed char	xc;
	signed char	yc;
	signed char	ra;
	unsigned char	cn;
};
