// CC BY
// code by SASANO Takayoshi

#include "misc.h"

int	isxdigit(int c)
{
	return ((c >= '0' && c <= '9') ||
		(c >= 'A' && c <= 'F') ||
		(c >= 'a' && c <= 'f'));
}

int	memcmp(const void *b1, const void *b2, int len)
{
	const unsigned char	*p1, *p2;
	int	r;

	p1 = b1;
	p2 = b2;
	r = 0;
	for (; len > 0; len--) {
		r = *p1 - *p2;
		if (r) break;
		p1++;
		p2++;
	}

	return r;
}

void	*memcpy(void *dst, const void *src, int len)
{
	char	*d;
	const char	*s;

	d = dst;
	s = src;
	for (; len > 0; len--) {
		*d = *s;
		d++;
		s++;
	}

	return dst;
}

void	*memset(void *b, int c, int len)
{
	char	*p;

	p = b;
	for (; len > 0; len--) {
		*p = c;
		p++;
	}

	return b;
}

int	strlen(const char *s)
{
	const char	*p;

	for (p = s; *p != '\0' ; p++);

	return p - s;
}
